org.apache.hc.core5.http.impl.nio

## Class ChunkDecoder

- java.lang.Object
- - org.apache.hc.core5.http.impl.nio.AbstractContentDecoder
  - - org.apache.hc.core5.http.impl.nio.ChunkDecoder

- All Implemented Interfaces:
    ContentDecoder

      public class ChunkDecoder
      extends AbstractContentDecoder

  Implements chunked transfer decoding. The content is received in small chunks. Entities transferred using this encoder can be of unlimited length.
  Since:
    4.0

- - ### Field Summary

    - ### Fields inherited from class org.apache.hc.core5.http.impl.nio.AbstractContentDecoder

      `completed`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ChunkDecoder(ReadableByteChannel channel, SessionInputBuffer buffer, BasicHttpTransportMetrics metrics)`
    `ChunkDecoder(ReadableByteChannel channel, SessionInputBuffer buffer, Http1Config http1Config, BasicHttpTransportMetrics metrics)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<? extends Header>` | `getTrailers()` Returns content trailers if available
    `int` | `read(ByteBuffer dst)` Reads a portion of content from the underlying channel
    `String` | `toString()`

    - ### Methods inherited from class org.apache.hc.core5.http.impl.nio.AbstractContentDecoder

      `buffer, channel, fillBufferFromChannel, isCompleted, metrics, readFromChannel, readFromChannel, setCompleted, setCompleted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ChunkDecoder

          public ChunkDecoder(ReadableByteChannel channel,
                      SessionInputBuffer buffer,
                      Http1Config http1Config,
                      BasicHttpTransportMetrics metrics)

      Since:
        4.4

    - #### ChunkDecoder

          public ChunkDecoder(ReadableByteChannel channel,
                      SessionInputBuffer buffer,
                      BasicHttpTransportMetrics metrics)

  - ### Method Detail

    - #### read

          public int read(ByteBuffer dst)
                   throws IOException

      Description copied from interface: `ContentDecoder`
      Reads a portion of content from the underlying channel
      Parameters:
        `dst` - The buffer into which entity content is to be transferred
      Returns:
        The number of bytes read, possibly zero, or -1 if the channel has reached end-of-stream
      Throws:
        `IOException` - if I/O error occurs while reading content

    - #### getTrailers

          public List<? extends Header> getTrailers()

      Description copied from interface: `ContentDecoder`
      Returns content trailers if available
      Specified by:
        `getTrailers` in interface `ContentDecoder`
      Overrides:
        `getTrailers` in class `AbstractContentDecoder`
      Returns:
        list of trailers

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2005–2020 The Apache Software Foundation. All rights reserved.